//+------------------------------------------------------------------+
//|                        Cross NonLag-TEMA with XARD SSA V1.7b.mq4 |
//|                                        Copyright  2010, IND-PC  |
//|                                        http://www.IND-PC.com     |
//+------------------------------------------------------------------+
#property copyright "Aaron Peterson - IND-PC 2010   aaron@ind-pc.com"
#property link      "http://www.ind-pc.com"


extern   double     LotSize = 0.5;
extern   int        StopLoss=40;
extern   int        TakeProfit = 100;
extern   int        BreakEven = 40;
extern   int        Magic = 12345;
extern   string     TradeComment = "UnclePips Rocks";
extern   string     NonLag_v7.1F = "Settings";
extern   int        Price = 0;
extern   int        Length=14;
extern   int        Displace=0;
extern   double     PctFilter=0.5;

static double trailing = 0.0;

double TakeProfitWithMultiplier, StopLossWithMultiplier;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
//----



int ticket, multiplier, found=0;
double orderSize, breakEven;

if(Digits == 2 || Digits == 4)
{
   multiplier = 1;
}
if(Digits == 3 || Digits == 5) 
{
   multiplier = 10;
}
if(Digits == 6) 
{
   multiplier = 100;   
}
if(Digits == 7) 
{
   multiplier = 1000;
}
   
TakeProfitWithMultiplier = TakeProfit*multiplier*Point; 
StopLossWithMultiplier = StopLoss*multiplier*Point;

breakEven = CheckBreakEven(multiplier);


double NoLag = iCustom(NULL, 0, "NonLagMA_v7.1F", Price, Length, Displace, PctFilter, 0,0);
double NoLagUp = iCustom(NULL, 0, "NonLagMA_v7.1F", Price, Length, Displace, PctFilter, 1, 0);
double NoLagDown = iCustom(NULL, 0, "NonLagMA_v7.1F", Price, Length, Displace, PctFilter, 2, 0);
Comment("NoLag: " + NoLag + " Pips: " + NormalizeDouble(breakEven,2));

if( NoLag == NoLagUp)//Cross for Buy
{
   Print("Start Buy");
   found = CloseSellOrders();  
   Print("SellOrdersClosed");
   BuyCross(found);
   Print("Buy Done");      
}
else if(NoLag == NoLagDown)//Cross for Sell
{
   Print("Start Sell");
   found = CloseBuyOrders();
   Print("BuyOrdersClosed");
   SellCross(found);
   Print(GetLastError());
   Print("Sell Done");
}

return(0);
  }
//+------------------------------------------------------------------+

double CheckBreakEven(int multiplier)
{
      for(int i=0;i<OrdersTotal();i++) 
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
         {
            if(OrderType()==OP_BUY)   //<-- Long position is opened
            {
               double gainValue = (OrderOpenPrice() - Ask) / Point / multiplier;
               if(gainValue > BreakEven)
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(),  OrderTakeProfit(), 0 , Blue);
               }
               else
               {
                  double slBuy = NormalizeDouble(Ask - StopLossWithMultiplier,Digits);
                  double tpBuy = NormalizeDouble(Ask + TakeProfitWithMultiplier,Digits);
                  if(OrderTakeProfit() == 0.0 || OrderStopLoss() == 0.0)
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), slBuy,  tpBuy, 0 , Blue);
                  }
               }
               return(gainValue);
            }
            if(OrderType()==OP_SELL) //<-- Go to short position
            {
               gainValue = 0;
               gainValue = ( Bid - OrderOpenPrice());// / Point / multiplier;
               gainValue/=Point;
               gainValue/=multiplier;

               if(gainValue > BreakEven)
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0 , Red);
               }
               else
               {
                  double slSell = NormalizeDouble(Bid + StopLossWithMultiplier,Digits);
                  double tpSell = NormalizeDouble(Bid - TakeProfitWithMultiplier, Digits);
                  if(OrderTakeProfit() == 0.0 || OrderStopLoss() == 0.0)
                  {
                    OrderModify(OrderTicket(), OrderOpenPrice(), slSell, tpSell, 0 , Red); 
                  }
               }
               return(gainValue);
            }
         }
      }
      
}


void BuyCross(int found)
{
   if(found==0)
   {
      int tickBuy = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 3, 0, 0, TradeComment, Magic, 0, Blue);
      Print("tickBuy " + tickBuy);
   }    

}

void SellCross(int found)
{
   if(found == 0)
   {
      int tickSell = OrderSend(Symbol(), OP_SELL,LotSize, Bid, 2, 0, 0, TradeComment, Magic, 0, Red);
      Print("tickSell " + tickSell);
   }
}

int CloseSellOrders()
{
   int ticket, found = 0;
   double orderSize;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true && OrderMagicNumber() == Magic)
      {
         if(OrderSymbol()== Symbol())
         {
            found++;
         }
      }
   }
   return(found);
}

int CloseBuyOrders()
{
   int ticket, found = 0;
   double orderSize;
   for(int i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true && OrderMagicNumber() == Magic)
      {
         if(OrderSymbol()== Symbol())
         {
            found++;
         }
      }
   }
   return(found);
}